//=============================================================================
// MSC121x EVM Test Program
//
// by nexp76@naver.com
//=============================================================================


/* 
 [2007.03.11]
 - 8051Ÿ̸ ׽Ʈ
 - 1ֱ LED On/Off
*/

#include "..\00_hal\system.h"
#include "..\01_drv\serial.c"


//-----------------------------------------------------------------------------
#define T0_MODE0         0  // TMOD.0 and TMOD.1
#define T0_INTERNAL_CLK  0  // TMOD.2
#define T0_CLOSED_GATE   0  // TMOD.3

#define T0_MODE1         1  // TMOD.0 and TMOD.1


#define T_10ms				(65536-(unsigned int)(XTAL/(OSC_PER_INST*100)))
#define T_10ms_H			(T_10ms/256)
#define T_10ms_L			(T_10ms%256)

#define T_50ms				(65536-(unsigned int)(XTAL/(OSC_PER_INST*20)))
#define T_50ms_H			(T_50ms/256)
#define T_50ms_L			(T_50ms%256)	
	

void InitTimer0(void)
{
	TMOD |= T0_MODE1 | T0_INTERNAL_CLK | T0_CLOSED_GATE;

    TL0 = T_10ms_L;
    TH0 = T_10ms_H;  
	
	ET0 = TRUE;
	TR0 = TRUE;
}
//-----------------------------------------------------------------------------

unsigned int m_TimeTick50ms = 0;


//-----------------------------------------------------------------------------
// Ÿ̸0 ÷ο ͷƮ  Լ
void Timer0Overflow(void) interrupt 1
{
      //ͷ ߻Ҷ Ÿ̸Ӱ  ش.
    TL0 = T_10ms_L;
    TH0 = T_10ms_H;  

	//Led1Toggle();

	m_TimeTick50ms++;
}
//-----------------------------------------------------------------------------


//-----------------------------------------------------------------------------
// Main Funiction
//-----------------------------------------------------------------------------
void main(void)
{
	int led_flash = TRUE;
	
	//Initialize CPU
	SystemInit();

	//Timer0 Initialize
	InitTimer0();
	enable();
	while(1)
	{
		if(led_flash)
		{
			//50x100 = 500ms
			if(m_TimeTick50ms>100)
			{
				Led1Toggle();
				m_TimeTick50ms = 0;
			}
		}
	}
}
//-----------------------------------------------------------------------------
